<?php

namespace GopNext\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class OperatingBudgetConclusionController {
    
    protected $crudService;
    protected $service;
  
    public function __construct($connection, $environment, $util, $crudService, $service) {
        $this->connection   = $connection;
        $this->environment  = $environment;
        $this->util         = $util;
        $this->crudService	= $crudService;
        $this->service      = $service;
    }
    
    public function completeBudget(Request\DataSet $request, Response $response) {
        $data = $request->getParameters();
        
        try {
            $this->service->beginTransaction();
            $nrLista = $this->util->insertLista($data['CDFILIAL']);
       		$this->service->completeBudget($data, $nrLista);
			$this->util->deleteLista($nrLista);
			
            $this->service->commit();
        } catch(\Exception $ex) {
            $this->service->rollback();
            $response->setError(new Error($ex->getMessage(), 500));
        }
    }
}
